/*

	  Zadanie z predmetu Programovacie Techniky cislo 3
  	 ---------------------------------------------------
       Inplementujte Binarny Strom v jazyku C, C++ alebo Pascal
                                                        
                                                        Rybar Peter
                                                         8.11.1998   

Specifikacia:
-------------
Druhy:
=====
	tree
	lab
	v

Operacie:
=========
        tree:			  -> tree	vytvorenie prazdneho stromu 
        getroot:	tree	  -> v		najdenie korena stromu 
        create:		tree, lab -> tree 	pridanie vrcholu do stromu 
        lnext:		tree, v   -> v		najdenie laveho nasledovnika 
        pneighbor:	tree, v   -> v		najdenie praveho suseda 
        decode:		tree, v   -> lab	precitanie ohodnotenia vrcholu 
    
Inplementacia:
--------------

 Implementacny jazyk:        C++
 Implementacne prostredie:   mcedit, make
 Implementovany typ:         binarny strom
 Implementujuci typ:         zretazena volna pamat
 Operacny system:            Unix, Linux
                             ^^^^^^^^^^^
  
Funkcie:
========
        tree: - vytvorenie prazdneho stromu 
               Vstup:	 
	       Vystup:	vrchol bez ohodnotenia
               Navrat:	vrchol bez ohodnotenia

        getroot: -> najdenie korena stromu 
               Vstup: 	binarny strom
	       Vystup:	ukazovatel na koren binarneho stromu
               Navrat:	ukazovatel na koren binarneho stromu

        create:	- pridanie vrcholu do stromu 
               Vstup:	morseho kod
			znak zodpovedajuci danemu kodu
	       Vystup:	strom s novou vetvou
               Navrat:	strom s novou vetvou

        lnext: - najdenie laveho nasledovnika 
               Vstup:	morseho kod
	       Vystup:	ukazovatel na prislusny vrcho binarneho stromu
               Navrat:	ukazovatel na prislusny vrcho binarneho stromu

        pneighbor: - najdenie praveho suseda 
               Vstup:	morseho kod
	       Vystup:	ukazovatel na praveho suseda alebo NULL	
               Navrat:	ukazovatel na praveho suseda alebo NULL		

        decode: - precitanie ohodnotenia vrcholu 
               Vstup:	morseho kod
	       Vystup:	ohodnotenie vrcholu
               Navrat:	ohodnotenie vrcholu

Kompilacia:
-----------
 Unix, Linux >	Zdrojovy subor skompilujeme pomocou standardnej 
                utility 'make', ktora sa postara o priebeh kompilacie
		programu a vytvori binarny subor.
  
Pouzitie:
---------  
  Program po spusteni caka na vstup Morseho kodu zo standardneho vstupu.
Po jeho zadani sa na standardnom vystupe vypise znak kodu zodpovedajuci.
Ukoncenie programu (zadavania kodov) je realizovane zaradenim znaku EOF, 
co zodpoveda klavesovej skratke Ctrl-D. 
  Takato realizacia je vhodna na desifrovanie kodu zadavaneho nie len 
zo standardneho vstupu, ale aj zo suboru. V takom pripade presmerujeme 
standardny vstup na vstup zo suboru code_file. 

Priklad:	tree < code_file

Ak chceme vystup desifrovaneho kodu do suboru, presmerujeme standardny 
vystup do nami zvoleneho suboru out_file. 

Priklad:	tree > out_file

Horeuvedene presmerovania mozno realizovat i sucastne.

Priklad:	tree < code_file > out_file

  Program pre svoju cinnost potrebuje subor code.map, ktory musi byt 
v tom istom adresari ako spustitelny program. Temto subor obsahuje 
informaciu (kodov mapu) morseho abecedy. Subor code.map si moze uzivatel
predefinovat a pouzivat tak vlastnu notaciu morseho kodu.

Obsah suboru code.map:
A   .- 
B   -... 
C   -.-. 
D   -.. 
E   . 
F   ..-. 
G   --. 
H   .... 
I   .. 
J   .--- 
K   -.- 
L   .-.. 
M   -- 
N   -. 
O   --- 
P   .--. 
Q   --.- 
R   .-. 
S   ... 
T   - 
U   ..- 
V   ...- 
W   .-- 
X   -..- 
Y   -.-- 
Z   --.. 
0   ----- 
1   .---- 
2   ..--- 
3   ...-- 
4   ....- 
5   ..... 
6   -.... 
7   --... 
8   ---.. 
9   ----. 
.   .-.-.- 
,   --..-- 
:   ..--..
EOF
  
Protokol o preklade:
--------------------
dmpc:(22:23)/DOS/users/peter/linux/elf/pt/tree% date
Sun Nov  8 22:23:44 CET 1998
dmpc:(22:23)/DOS/users/peter/linux/elf/pt/tree% make
g++ -O2 -c tree.cc
g++ -O2 tree.o -o tree
      -- OK --
dmpc:(22:23)/DOS/users/peter/linux/elf/pt/tree% ls -la
total 128
drwxrwxr-x   2 rybar    rybar       16384 Nov  8 22:23 ./
drwxrwxr-x   6 rybar    rybar       16384 Nov  3 20:52 ../
-rw-r--r--   1 rybar    rybar         275 Nov  8 21:31 Makefile
-rw-rw-r--   1 rybar    rybar         306 Nov  6 13:27 code.map
-rw-rw-r--   1 rybar    rybar         227 Nov  6 11:48 kod
-rwxrwxr-x   1 rybar    rybar        7648 Nov  8 22:23 tree*
-rw-r--r--   1 rybar    rybar        8550 Nov  8 22:22 tree.cc
-rw-rw-r--   1 rybar    rybar        3604 Nov  8 22:23 tree.o
dmpc:(22:24)/DOS/users/peter/linux/elf/pt/tree%

Zhodnotenie: 
-------------
  Program je funkcny , jednoucelovych a spnil poziadavky zadania.
Je mozne ho este rosirit o moznost kodovania do Morseho kodu.


Makefile:
---------
CC=g++
CFLAGS=-O2 
#CFLAGS=-O2 -static
#CFLAGS=-g -Debug

all:	tree.o
	$(CC) $(CFLAGS) tree.o -o tree
	@ echo "      -- OK --      "
tree.o: tree.cc
	$(CC) $(CFLAGS) -c tree.cc

clean:
	rm -f tree *.o core *~;

EOF

*/

/*
*****************************************************************
*                        Zdrojovy text				*
*****************************************************************
*/

#include<stdio.h>
#include<string.h>

class tree
{
  private:
    struct cell {		/* bunka stromu */
        char k;
	cell *left;
	cell *right;
	};
    cell* root;				/* uazovatel na bunku stromu */

  public:
    tree();				/* vytvorenie prazdneho stromu */
    cell *getroot();			/* najdenie korena stromu */
    void create(char *key, char znak);	/* pridanie vrcholu do stromu */
    cell *target(char *key);		/* najdenie vrcholu podla cesty */
    cell *lnext(char *key);		/* najdenie laveho nasledovnika */
    cell *pneighbor(char *key);		/* najdenie praveho suseda */
    char decode(char *key);		/* precitanie ohodnotenia vrcholu */
    ~tree();				/* zrusenie stromu */
};

tree::tree()				/* konstruktor */
{
  root = (cell *) new(cell);
  root->k = ' ';
  root->left = NULL;
  root->right = NULL;
}

tree::cell *tree::getroot()		/* najdenie korena stromu */
{
  return root;
}

void tree::create(char *key, char znak)   /* vytvorenie podstromu */
{
  int i,d;
  cell *help, *index;
  
  d = strlen(key);
  if (d == 0) return;

  index = root;

  for (i = 0; i < d; i++)		/* pohyb po strome */
  {
	if(key[i] == '.')
	{
	  if (index->left == NULL)
	  {
		help = (cell *) new(cell); 	/* nova bunka */
		help->left = NULL;
		help->right = NULL;
		help->k = ' ';
		index->left = help;
		index = help;
	  }
	  else index = index->left;
	}
	else
	{
	  if (index->right == NULL)
	  {
		help = (cell *) new(cell);	/* nova bunka */
		help->left = NULL;
		help->right = NULL;
		help->k = ' ';
		index->right = help;
		index = help;
	  }
	  else index = index->right;
	}
  }
  index->k = znak;		/* priradenie ohodnotenia */
}

tree::cell *tree::target(char *key)	/* najdenie polozky podla cesty */
{
  cell *index;
  int i,d;

  d = strlen(key);
  index = root;
  for(i = 0; i < d; i++)		/* pohyb po strome */
  {
	if (index == NULL) return NULL;
	if(key[i] == '-') index = index->right;
	else index = index->left;
  }
  return index;
}

tree::cell *tree::lnext(char *key)
{
  return (((cell *) target(key))->left);
}

tree::cell *tree::pneighbor(char *key)
{
  cell *index;
  int i,d;

  d = strlen(key);
  if(key[d-2] == '-') return NULL;
  index = root;
  for(i = 0; i < (d-1); i++)		/* pohyb po strome */
  {
	if (index == NULL) return NULL;
	if(key[i] == '-') index = index->right;
	else index = index->left;
  }
  return index->right;
}

char tree::decode(char *key)       /* dekodovanie morzeoveho kodu */ 
{
  cell *index;

  index = (cell *) target(key);
  return index->k;
}

tree::~tree()				/* destruktor */
{
  cell *index, *preindex = NULL;

  index = root;
  
  while(!((root->left == NULL) && (root->right == NULL)))
  {
    index = root;
    while(1)
    {
	while(index->left != NULL)
	{
	    preindex = index;
	    index = index->left;
	}
	if(index->right != NULL) 
	{
	    preindex = index;
	    index = index->right;
	}else 
	{
#ifdef ebug
	    printf(" p=%p pl=%p pr=%p i=%p il=%p ir=%p\t|%c|\n",
		    preindex, preindex->left,preindex->right, index,
		    index->left, index->left, index->k);
#endif
	    if(preindex->left == index) preindex->left = NULL;
	    else preindex->right = NULL;
    	    delete (index); 
	    break;
        }
    } 
  }
}

/************************ main ****************************************/

#define M 7

int main (void)
{
  char kod[ M + 1], znak;
  FILE *map;

  tree t;		/* deklaracia a inicializacia stromu */

  if((map = fopen("code.map", "r")) == NULL) {
    fprintf(stderr, "Error: Cannot open code.map file.\n");
    return 1;
  }

  while(fscanf(map, "%s%s", &znak, kod) != EOF) {   /* vytvorenie stromu */
#ifdef ebug
    printf("znak=%c kod=%s\n", znak, kod);
#endif
    t.create(kod, znak);  
  }
  fclose(map);
/*  v zdrjovom texte by sa to definovalo na tvrdo takto:
  t.create(".-",'a');
  t.create("....",'h');       
  t.create(".",'i');
  t.create("-...",'b');
  t.create("---",'o');
  t.create("...",'s');
  */
  printf("\n"); 
  
  printf("
[38m");
  while(scanf("%s", kod) != EOF) {
    printf("%c", t.decode(kod));
  }
  printf("\n[29m\n"); 
  return 0;
}
